
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

class LockableJFrame extends JFrame {
  
  LockableJFrame(String title) {
    super(title);
    MouseInputListener mil = new MouseInputAdapter() {};
    JComponent ngp = new JComponent() {
	public void paint(Graphics g) {
	  Rectangle r = g.getClipBounds();
	  Color oldc = g.getColor();
	  g.setColor(new Color(127,127,127,127));
	  g.fillRect(r.x,r.y,r.width,r.height);
	  g.setColor(oldc);
	}
      };
    ngp.addMouseListener(mil);
    ngp.addMouseMotionListener(mil);
    setGlassPane(ngp);
  }

  public void lockGUI() {
    getGlassPane().setVisible(true);
    getGlassPane().setCursor(new Cursor(Cursor.WAIT_CURSOR));
    if (getJMenuBar() != null)
      getJMenuBar().setEnabled(false);
  }

  public void unlockGUI() {
    getGlassPane().setVisible(false);
    getGlassPane().setCursor(Cursor.getDefaultCursor());
    if (getJMenuBar() != null)
      getJMenuBar().setEnabled(true);
  }

}
