
/** 
 * External representation of a reference to a DenovoDP.Endpoint
 */
class AcidWithPeak {
  Peak peak;
  AminoAcid acid;
  AcidWithPeak(Peak p, AminoAcid a) {
    peak = p;
    acid = a;
  }
  public String toString() {
    return acid != null ? (acid.abbr + "(" + peak.x + ")") :  
      "(" + peak.x + ")"; 
  }
}
