
import java.util.*;

/**
 * A List of Strings, with efficient forwards or backwards concatenation
 */
class StringList extends LinkedList /* of String */ {
  public StringBuffer toStringBuffer(boolean reversed) {
    StringBuffer res = new StringBuffer();
    if (!reversed) {
      ListIterator lstIter = listIterator();
      while (lstIter.hasNext()) 
	res.append((String)lstIter.next()); 
    } else {
      ListIterator lstIter = listIterator(size());
      while (lstIter.hasPrevious()) 
	res.append((String)lstIter.previous()); 
    }
    return res;
  }
}

